/*
** Format of NODELIST.RDX (Raw-Index):
**
** The Indexfile starts with the "Index-Header":
** struct HEADER
**        	version  - 0xMMmm (M=Major version, m=minor version)
**					datetime - Time and date of creation (POSIX 1003.1)
**					nodelists- Number of compiled nodelists in that file
**					flag     - 0=entries are unsorted (like in this demo)
**										 1=entries are sorted; sort-priority: nodelist,zone,net,node,point
**
** Then one (or more) "Nodelists-Header" are following (the number of
** nodelists header is defined in "header.nodelists").
** struct NLHEADER
**					type     - 0=list is a nodelist; 1=list is a pointlist
**					day			 - Daynumber of nodelist/pointlist
**					network	 - Network (e.g. fidonet, atarinet, nest); case independant
**          file		 - Full path to nodelist/pointlist
**
** Then all nodelist entries are following:
** struct ENTRY
**					nodelist - Number of belonging NLHEADER (0 based)
**          zone,net,
**					node,point- Address
**          f_flags  - Flags (see below)
**					m_flags  - Flags (see below)
**          offset   - Offset in raw nodelist
*/

typedef struct HEADERtag
{	uword	version;
	ulong	datetime;
	uword	nodelists;
	uword flag;
} HEADER;

typedef struct NLHEADERtag
{	uword	type;
	uword day;
	ubyte network[32];
	ubyte	file[256];
} NLHEADER;

typedef struct ENTRYtag
{	uword	nodelist;					/* 0-Based */
	uword	zone,net,node,point;
	uword f_flags,m_flags;
	ulong	offset;
} ENTRY;

#define FALSE 0
#define TRUE	1